diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/types/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/types/__init__.py
index 8ea7aa9..737605d 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/types/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/types/__init__.py
@@ -28,6 +28,42 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection(did=kwargs['did'])
+
+        # We need datlastsysoid to check if current type is system type
+        self.datlastsysoid = self.manager.db_info[kwargs['did']]['datlastsysoid']
+
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        # Declare allows acl on type
+        self.acl = ['U']
+
+        # we will set template path for sql scripts
+        self.template_path = 'type/sql/9.1_plus'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class TypeModule(SchemaChildModule):
     """
      class TypeModule(SchemaChildModule)
@@ -65,11 +101,23 @@ class TypeModule(SchemaChildModule):
         self.min_ver = None
         self.max_ver = None
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid):
         """
         Generate the collection node
         """
-        yield self.generate_browser_collection_node(scid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path,'nodes.sql']),
+                                   scid=scid, show_system_objects=self.show_system_objects)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(scid, collection_count)
 
     @property
     def script_load(self):
@@ -208,41 +256,6 @@ class TypeView(PGChildNodeView, DataTypeReader):
                                    {'get': 'get_external_functions_list'}]
     })
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection(did=kwargs['did'])
-
-            # We need datlastsysoid to check if current type is system type
-            self.datlastsysoid = self.manager.db_info[kwargs['did']]['datlastsysoid']
-
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            # Declare allows acl on type
-            self.acl = ['U']
-
-            # we will set template path for sql scripts
-            self.template_path = 'type/sql/9.1_plus'
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid, did, scid):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/views/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/views/__init__.py
index 317a488..43d3617 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/views/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/views/__init__.py
@@ -43,6 +43,65 @@ from config import PG_DEFAULT_DRIVER
 """
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to instance of the method.
+
+    Assumptions:
+        This function will always be used as decorator of a class method.
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        pg_driver = get_driver(PG_DEFAULT_DRIVER)
+        self.qtIdent = pg_driver.qtIdent
+        self.manager = pg_driver.connection_manager(
+            kwargs['sid']
+        )
+        self.conn = self.manager.connection(did=kwargs['did'])
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext("Connection to the server has been lost!")
+            )
+        self.datlastsysoid = self.manager.db_info[
+            kwargs['did']]['datlastsysoid']
+
+        # Set template path for sql scripts
+        if hasattr(self, 'NODE_TYPE'):
+            initial_path = self.NODE_TYPE
+        else:
+            initial_path = self.template_initial
+
+        if initial_path == 'view':
+            self.template_path = initial_path + '/' + (
+                ViewNode.ppas_template_path(self.manager.version)
+                if self.manager.server_type == 'ppas' else
+                ViewNode.pg_template_path(self.manager.version)
+            )
+        else:
+            self.template_path = initial_path + '/' + (
+                MViewNode.ppas_template_path(self.manager.version)
+                if self.manager.server_type == 'ppas' else
+                MViewNode.pg_template_path(self.manager.version)
+            )
+
+        ver = self.manager.version
+        if ver >= 90200:
+            self.column_template_path = 'column/sql/9.2_plus'
+        else:
+            self.column_template_path = 'column/sql/9.1_plus'
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class ViewModule(SchemaChildModule):
     """
     class ViewModule(SchemaChildModule):
@@ -79,11 +138,23 @@ class ViewModule(SchemaChildModule):
         self.min_ver = None
         self.max_ver = None
 
+    @check_precondition
     def get_nodes(self, gid, sid, did, scid):
         """
         Generate the collection node
         """
-        yield self.generate_browser_collection_node(scid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join(
+            [self.template_path, 'sql/properties.sql']), scid=scid)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(scid, collection_count)
 
     @property
     def script_load(self):
@@ -150,53 +221,6 @@ view_blueprint = ViewModule(__name__)
 mview_blueprint = MViewModule(__name__)
 
 
-def check_precondition(f):
-    """
-    This function will behave as a decorator which will checks
-    database connection before running view, it will also attaches
-    manager,conn & template_path properties to instance of the method.
-
-    Assumptions:
-        This function will always be used as decorator of a class method.
-    """
-
-    @wraps(f)
-    def wrap(*args, **kwargs):
-
-        # Here args[0] will hold self & kwargs will hold gid,sid,did
-        self = args[0]
-        pg_driver = get_driver(PG_DEFAULT_DRIVER)
-        self.qtIdent = pg_driver.qtIdent
-        self.manager = pg_driver.connection_manager(
-            kwargs['sid']
-        )
-        self.conn = self.manager.connection(did=kwargs['did'])
-        # If DB not connected then return error to browser
-        if not self.conn.connected():
-            return precondition_required(
-                gettext("Connection to the server has been lost!")
-            )
-        self.datlastsysoid = self.manager.db_info[
-            kwargs['did']]['datlastsysoid']
-
-        # Set template path for sql scripts
-        self.template_path = self.template_initial + '/' + (
-            self.ppas_template_path(self.manager.version)
-            if self.manager.server_type == 'ppas' else
-            self.pg_template_path(self.manager.version)
-        )
-
-        ver = self.manager.version
-        if ver >= 90200:
-            self.column_template_path = 'column/sql/9.2_plus'
-        else:
-            self.column_template_path = 'column/sql/9.1_plus'
-
-        return f(*args, **kwargs)
-
-    return wrap
-
-
 class ViewNode(PGChildNodeView, VacuumSettings):
     """
     This class is responsible for generating routes for view node.
diff --git a/web/pgadmin/browser/server_groups/servers/resource_groups/__init__.py b/web/pgadmin/browser/server_groups/servers/resource_groups/__init__.py
index 749e543..2f19499 100644
--- a/web/pgadmin/browser/server_groups/servers/resource_groups/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/resource_groups/__init__.py
@@ -25,6 +25,35 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,did
+        self = args[0]
+        self.driver = get_driver(PG_DEFAULT_DRIVER)
+        self.manager = self.driver.connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection()
+
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        self.template_path = 'resource_groups/sql'
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class ResourceGroupModule(CollectionNodeModule):
     """
      class ResourceGroupModule(CollectionNodeModule)
@@ -68,6 +97,7 @@ class ResourceGroupModule(CollectionNodeModule):
         self.max_ver = None
         self.server_type = ['ppas']
 
+    @check_precondition
     def get_nodes(self, gid, sid):
         """
         Method is used to generate the browser collection node
@@ -76,7 +106,17 @@ class ResourceGroupModule(CollectionNodeModule):
             gid: Server Group ID
             sid: Server ID
         """
-        yield self.generate_browser_collection_node(sid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'properties.sql']))
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(sid, collection_count)
 
     @property
     def node_inode(self):
@@ -201,34 +241,6 @@ class ResourceGroupView(NodeView):
             200, {'Content-Type': 'application/x-javascript'}
         )
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,did
-            self = args[0]
-            self.driver = get_driver(PG_DEFAULT_DRIVER)
-            self.manager = self.driver.connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection()
-
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            self.template_path = 'resource_groups/sql'
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid):
         """
diff --git a/web/pgadmin/browser/server_groups/servers/roles/__init__.py b/web/pgadmin/browser/server_groups/servers/roles/__init__.py
index bee3d02..56f344a 100644
--- a/web/pgadmin/browser/server_groups/servers/roles/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/roles/__init__.py
@@ -24,6 +24,122 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(action=None):
+    """
+    This function will behave as a decorator which will checks the status
+    of the database connection for the maintainance database of the server,
+    beforeexecuting rest of the operation for the wrapped function. It will
+    also attach manager, conn (maintenance connection for the server) as
+    properties of the instance.
+    """
+
+    def wrap(f):
+        @wraps(f)
+        def wrapped(self, **kwargs):
+            self.manager = get_driver(
+                PG_DEFAULT_DRIVER
+            ).connection_manager(
+                kwargs['sid']
+            )
+            self.conn = self.manager.connection()
+
+            driver = get_driver(PG_DEFAULT_DRIVER)
+            self.qtIdent = driver.qtIdent
+
+            if not self.conn.connected():
+                return precondition_required(
+                    _("Connection to the server has been lost!")
+                )
+
+            ver = self.manager.version
+
+            self.sql_path = 'role/sql/{0}/'.format(
+                'post9_4' if ver >= 90500 else \
+                    'post9_1' if ver >= 90200 else \
+                        'post9_0' if ver >= 90100 else \
+                            'post8_4'
+            )
+
+            self.alterKeys = [
+                u'rolcanlogin', u'rolsuper', u'rolcreatedb',
+                u'rolcreaterole', u'rolinherit', u'rolreplication',
+                u'rolconnlimit', u'rolvaliduntil', u'rolpassword'
+            ] if ver >= 90200 else [
+                u'rolcanlogin', u'rolsuper', u'rolcreatedb',
+                u'rolcreaterole', u'rolinherit', u'rolconnlimit',
+                u'rolvaliduntil', u'rolpassword'
+            ]
+
+            check_permission = False
+            fetch_name = False
+            forbidden_msg = None
+
+            if action in ['drop', 'update']:
+                check_permission = True
+                fetch_name = True
+                if action == 'drop':
+                    forbidden_msg = _(
+                        "The current user does not have permission to drop the role."
+                    )
+                else:
+                    forbidden_msg = _(
+                        "The current user does not have permission to update the role."
+                    )
+            elif action == 'create':
+                check_permission = True
+                forbidden_msg = _(
+                    "The current user does not have permission to create the role."
+                )
+            elif (action == 'msql' and
+                          'rid' in kwargs and kwargs['rid'] != -1):
+                fetch_name = True
+
+            if check_permission:
+                user = self.manager.user_info
+
+                if not user['is_superuser'] and \
+                        not user['can_create_role']:
+                    if (action != 'update' or
+                                        'rid' in kwargs and kwargs['rid'] != -1 and
+                                    user['id'] != kwargs['rid']):
+                        return forbidden(forbidden_msg)
+
+            if fetch_name:
+
+                status, res = self.conn.execute_dict(
+                    render_template(
+                        self.sql_path + 'permission.sql',
+                        rid=kwargs['rid'],
+                        conn=self.conn
+                    )
+                )
+
+                if not status:
+                    return internal_server_error(
+                        _(
+                            "Error retrieving the role information.\n{0}"
+                        ).format(res)
+                    )
+
+                if len(res['rows']) == 0:
+                    return gone(
+                        _("Couldn't find the role on the database server.")
+                    )
+
+                row = res['rows'][0]
+
+                self.role = row['rolname']
+                self.rolCanLogin = row['rolcanlogin']
+                self.rolCatUpdate = row['rolcatupdate']
+                self.rolSuper = row['rolsuper']
+
+            return f(self, **kwargs)
+
+        return wrapped
+
+    return wrap
+
+
 class RoleModule(CollectionNodeModule):
     NODE_TYPE = 'role'
     COLLECTION_LABEL = _("Login/Group Roles")
@@ -34,12 +150,23 @@ class RoleModule(CollectionNodeModule):
 
         super(RoleModule, self).__init__(*args, **kwargs)
 
+    @check_precondition(action='nodes')
     def get_nodes(self, gid, sid):
         """
         Generate the collection node
         """
         if self.show_node:
-            yield self.generate_browser_collection_node(sid)
+            collection_count = 0
+
+            count_sql = 'SELECT count(*) FROM( '
+            node_sql = render_template(self.sql_path + 'nodes.sql')
+            count_sql += node_sql + ' ) AS collection_count'
+
+            status, rset = self.conn.execute_scalar(count_sql)
+            if status:
+                collection_count = rset
+
+            yield self.generate_browser_collection_node(sid, collection_count)
         pass
 
     @property
@@ -429,121 +556,6 @@ rolmembership:{
 
         return wrap
 
-    def check_precondition(action=None):
-        """
-        This function will behave as a decorator which will checks the status
-        of the database connection for the maintainance database of the server,
-        beforeexecuting rest of the operation for the wrapped function. It will
-        also attach manager, conn (maintenance connection for the server) as
-        properties of the instance.
-        """
-
-        def wrap(f):
-            @wraps(f)
-            def wrapped(self, **kwargs):
-                self.manager = get_driver(
-                    PG_DEFAULT_DRIVER
-                ).connection_manager(
-                    kwargs['sid']
-                )
-                self.conn = self.manager.connection()
-
-                driver = get_driver(PG_DEFAULT_DRIVER)
-                self.qtIdent = driver.qtIdent
-
-                if not self.conn.connected():
-                    return precondition_required(
-                        _("Connection to the server has been lost!")
-                    )
-
-                ver = self.manager.version
-
-                self.sql_path = 'role/sql/{0}/'.format(
-                    'post9_4' if ver >= 90500 else \
-                        'post9_1' if ver >= 90200 else \
-                            'post9_0' if ver >= 90100 else \
-                                'post8_4'
-                )
-
-                self.alterKeys = [
-                    u'rolcanlogin', u'rolsuper', u'rolcreatedb',
-                    u'rolcreaterole', u'rolinherit', u'rolreplication',
-                    u'rolconnlimit', u'rolvaliduntil', u'rolpassword'
-                ] if ver >= 90200 else [
-                    u'rolcanlogin', u'rolsuper', u'rolcreatedb',
-                    u'rolcreaterole', u'rolinherit', u'rolconnlimit',
-                    u'rolvaliduntil', u'rolpassword'
-                ]
-
-                check_permission = False
-                fetch_name = False
-                forbidden_msg = None
-
-                if action in ['drop', 'update']:
-                    check_permission = True
-                    fetch_name = True
-                    if action == 'drop':
-                        forbidden_msg = _(
-                            "The current user does not have permission to drop the role."
-                        )
-                    else:
-                        forbidden_msg = _(
-                            "The current user does not have permission to update the role."
-                        )
-                elif action == 'create':
-                    check_permission = True
-                    forbidden_msg = _(
-                        "The current user does not have permission to create the role."
-                    )
-                elif (action == 'msql' and
-                              'rid' in kwargs and kwargs['rid'] != -1):
-                    fetch_name = True
-
-                if check_permission:
-                    user = self.manager.user_info
-
-                    if not user['is_superuser'] and \
-                            not user['can_create_role']:
-                        if (action != 'update' or
-                                            'rid' in kwargs and kwargs['rid'] != -1 and
-                                        user['id'] != kwargs['rid']):
-                            return forbidden(forbidden_msg)
-
-                if fetch_name:
-
-                    status, res = self.conn.execute_dict(
-                        render_template(
-                            self.sql_path + 'permission.sql',
-                            rid=kwargs['rid'],
-                            conn=self.conn
-                        )
-                    )
-
-                    if not status:
-                        return internal_server_error(
-                            _(
-                                "Error retrieving the role information.\n{0}"
-                            ).format(res)
-                        )
-
-                    if len(res['rows']) == 0:
-                        return gone(
-                            _("Couldn't find the role on the database server.")
-                        )
-
-                    row = res['rows'][0]
-
-                    self.role = row['rolname']
-                    self.rolCanLogin = row['rolcanlogin']
-                    self.rolCatUpdate = row['rolcatupdate']
-                    self.rolSuper = row['rolsuper']
-
-                return f(self, **kwargs)
-
-            return wrapped
-
-        return wrap
-
     @check_precondition(action='list')
     def list(self, gid, sid):
         status, res = self.conn.execute_dict(
diff --git a/web/pgadmin/browser/server_groups/servers/tablespaces/__init__.py b/web/pgadmin/browser/server_groups/servers/tablespaces/__init__.py
index 3bed5f9..3211ae8 100644
--- a/web/pgadmin/browser/server_groups/servers/tablespaces/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/tablespaces/__init__.py
@@ -25,15 +25,68 @@ from pgadmin.utils.driver import get_driver
 from config import PG_DEFAULT_DRIVER
 
 
+def check_precondition(f):
+    """
+    This function will behave as a decorator which will checks
+    database connection before running view, it will also attaches
+    manager,conn & template_path properties to self
+    """
+
+    @wraps(f)
+    def wrap(*args, **kwargs):
+        # Here args[0] will hold self & kwargs will hold gid,sid,tsid
+        self = args[0]
+        self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
+        self.conn = self.manager.connection()
+
+        # If DB not connected then return error to browser
+        if not self.conn.connected():
+            current_app.logger.warning(
+                "Connection to the server has been lost!"
+            )
+            return precondition_required(
+                gettext(
+                    "Connection to the server has been lost!"
+                )
+            )
+
+        ver = self.manager.version
+        if ver >= 90200:
+            self.template_path = 'tablespaces/sql/9.2_plus'
+        else:
+            self.template_path = 'tablespaces/sql/9.1_plus'
+        current_app.logger.debug(
+            "Using the template path: %s", self.template_path
+        )
+        # Allowed ACL on tablespace
+        self.acl = ['C']
+
+        return f(*args, **kwargs)
+
+    return wrap
+
+
 class TablespaceModule(CollectionNodeModule):
     NODE_TYPE = 'tablespace'
     COLLECTION_LABEL = gettext("Tablespaces")
 
+    @check_precondition
     def get_nodes(self, gid, sid):
         """
         Generate the collection node
         """
-        yield self.generate_browser_collection_node(sid)
+        collection_count = 0
+
+        count_sql = 'SELECT count(*) FROM( '
+        node_sql = render_template("/".join([self.template_path, 'nodes.sql']),
+                                   conn=self.conn)
+        count_sql += node_sql + ' ) AS collection_count'
+
+        status, rset = self.conn.execute_scalar(count_sql)
+        if status:
+            collection_count = rset
+
+        yield self.generate_browser_collection_node(sid, collection_count)
 
     @property
     def script_load(self):
@@ -93,46 +146,6 @@ class TablespaceView(PGChildNodeView):
             200, {'Content-Type': 'application/x-javascript'}
         )
 
-    def check_precondition(f):
-        """
-        This function will behave as a decorator which will checks
-        database connection before running view, it will also attaches
-        manager,conn & template_path properties to self
-        """
-
-        @wraps(f)
-        def wrap(*args, **kwargs):
-            # Here args[0] will hold self & kwargs will hold gid,sid,tsid
-            self = args[0]
-            self.manager = get_driver(PG_DEFAULT_DRIVER).connection_manager(kwargs['sid'])
-            self.conn = self.manager.connection()
-
-            # If DB not connected then return error to browser
-            if not self.conn.connected():
-                current_app.logger.warning(
-                    "Connection to the server has been lost!"
-                )
-                return precondition_required(
-                    gettext(
-                        "Connection to the server has been lost!"
-                    )
-                )
-
-            ver = self.manager.version
-            if ver >= 90200:
-                self.template_path = 'tablespaces/sql/9.2_plus'
-            else:
-                self.template_path = 'tablespaces/sql/9.1_plus'
-            current_app.logger.debug(
-                "Using the template path: %s", self.template_path
-            )
-            # Allowed ACL on tablespace
-            self.acl = ['C']
-
-            return f(*args, **kwargs)
-
-        return wrap
-
     @check_precondition
     def list(self, gid, sid):
         SQL = render_template(
diff --git a/web/pgadmin/browser/utils.py b/web/pgadmin/browser/utils.py
index 9799586..fc4fe5e 100644
--- a/web/pgadmin/browser/utils.py
+++ b/web/pgadmin/browser/utils.py
@@ -15,7 +15,7 @@ import flask
 from flask import render_template, current_app
 from flask_babel import gettext
 from flask.views import View, MethodViewType, with_metaclass
-from pgadmin.utils.ajax import make_json_response, precondition_required
+from pgadmin.utils.ajax import make_json_response, precondition_required, gone
 
 from config import PG_DEFAULT_DRIVER
 
@@ -128,7 +128,8 @@ class NodeView(with_metaclass(MethodViewType, View)):
         'dependency': [{'get': 'dependencies'}],
         'dependent': [{'get': 'dependents'}],
         'children': [{'get': 'children'}],
-        'module.js': [{}, {}, {'get': 'module_js'}]
+        'module.js': [{}, {}, {'get': 'module_js'}],
+        'coll': [{}, {'get': 'collection'}]
     })
 
     @classmethod
@@ -289,6 +290,14 @@ class NodeView(with_metaclass(MethodViewType, View)):
             )
         )
 
+    def collection(self, *args, **kwargs):
+        """Build the collection node."""
+        for d in self.blueprint.get_nodes(*args, **kwargs):
+            return make_json_response(
+                data=d
+            )
+        return gone(gettext("Couldn't find the object information."))
+
 
 class PGChildNodeView(NodeView):
     def children(self, **kwargs):
